# tr1/functional File Reference

## Detailed Description

This is a TR1 C++ Library header.

Definition in file tr1/functional.

Go to the source code of this file.

## Namespaces

- namespace std
- namespace std::tr1

## Defines

- #define _GLIBCXX_JOIN(X, Y)
- #define _GLIBCXX_JOIN2(X, Y)
- #define _GLIBCXX_JOIN3(X, Y)
- #define _GLIBCXX_REPEAT_HEADER
- #define _GLIBCXX_REPEAT_HEADER
- #define _GLIBCXX_REPEAT_HEADER
- #define _TR1_FUNCTIONAL
- #define tr1_hashtable_define_trivial_hash(T)

## Enumerations

- enum _Manager_operation { __get_type_info, __get_functor_ptr, __clone_functor, __destroy_functor }

## Functions

- template<typename _Member, typename _Class> _Mem_fn< _Member _Class::* > __callable_functor (_Member _Class::*const &__p)
- template<typename _Member, typename _Class> _Mem_fn< _Member _Class::* > __callable_functor (_Member _Class::*&__p)
- template<typename _Functor> _Functor & __callable_functor (_Functor &__f)
- template<typename _Tp> reference_wrapper< const _Tp > cref (reference_wrapper< _Tp > __t)
- template<typename _Tp, typename _Class> _Mem_fn< _Tp _Class::* > mem_fn (_Tp _Class::*__pm)
- template<typename _Signature> bool operator!= (_M_clear_type *, const function< _Signature > &__f)
- template<typename _Signature> bool operator!= (const function< _Signature > &__f, _M_clear_type *)
- template<typename _Signature> bool operator== (_M_clear_type *, const function< _Signature > &__f)
- template<typename _Signature> bool operator== (const function< _Signature > &__f, _M_clear_type *)
- template<typename _Tp> reference_wrapper< _Tp > ref (reference_wrapper< _Tp > __t)
- template<typename _Signature> void swap (function< _Signature > &__x, function< _Signature > &__y)
- tr1_hashtable_define_trivial_hash (double)
- tr1_hashtable_define_trivial_hash (float)
- tr1_hashtable_define_trivial_hash (long)
- tr1_hashtable_define_trivial_hash (int)
- tr1_hashtable_define_trivial_hash (short)
- tr1_hashtable_define_trivial_hash (wchar_t)
- tr1_hashtable_define_trivial_hash (unsigned char)
- tr1_hashtable_define_trivial_hash (signed char)
- tr1_hashtable_define_trivial_hash (char)
- tr1_hashtable_define_trivial_hash (bool)

## Function Documentation

_Mem_fn<_Tp _Class::*> std::tr1::mem_fn | ( | _Tp _Class::* | __pm | ) | `[inline]`

| Returns a function object that forwards to the member pointer pm. Definition at line 500 of file tr1/functional.

bool std::tr1::operator!= | ( | _M_clear_type * | ,
|  | const function< _Signature > & | __f
| ) | `[inline]`

| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Definition at line 1062 of file tr1/functional.

bool std::tr1::operator!= | ( | const function< _Signature > & | __f,
|  | _M_clear_type * |
| ) | `[inline]`

Compares a polymorphic function object wrapper against 0 (the NULL pointer).

Returns:
  `false` if the wrapper has no target, `true` otherwise

This function will not throw an exception.

Definition at line 1052 of file tr1/functional.

bool std::tr1::operator== | ( | _M_clear_type * | ,
|  | const function< _Signature > & | __f
| ) | `[inline]`

| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Definition at line 1038 of file tr1/functional.

bool std::tr1::operator== | ( | const function< _Signature > & | __f,
|  | _M_clear_type * |
| ) | `[inline]`

Compares a polymorphic function object wrapper against 0 (the NULL pointer).

Returns:
  `true` if the wrapper has no target, `false` otherwise

This function will not throw an exception.

Definition at line 1028 of file tr1/functional.

void std::tr1::swap | ( | function< _Signature > & | __x,
|  | function< _Signature > & | __y
| ) | `[inline]`

| Swap the targets of two polymorphic function object wrappers. This function will not throw an exception. Definition at line 1076 of file tr1/functional. References std::swap().